/* A Bison parser, made by GNU Bison 3.4.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         amd_parse
#define yylex           amd_lex
#define yyerror         amd_error
#define yydebug         amd_debug
#define yynerrs         amd_nerrs

#define yylval          amd_lval
#define yychar          amd_char

/* First part of user prologue.  */
#line 1 "amd_parse.y"

/* ----------------------------------------------------------------------- *
 *
 *  Copyright 2013 Ian Kent <raven@themaw.net>
 *  Copyright 2013 Red Hat, Inc.
 *  All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
 *  USA; either version 2 of the License, or (at your option) any later
 *  version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 * ----------------------------------------------------------------------- */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <ctype.h>
#include <sys/ioctl.h>
#include <syslog.h>

#include "automount.h"
#include "parse_amd.h"
#include "log.h"

#define MAX_OPTS_LEN	1024
#define MAX_ERR_LEN	3096

static pthread_mutex_t parse_mutex = PTHREAD_MUTEX_INITIALIZER;

extern FILE *amd_in;
extern char *amd_text;
extern int amd_lex(void);
extern void amd_set_scan_buffer(const char *);

static char *amd_strdup(char *);
static void amd_set_value(char **, char *);
static void local_init_vars(void);
static void local_free_vars(void);

static int amd_error(const char *s);
static int amd_notify(const char *s);
static int amd_info(const char *s);
static int amd_msg(const char *s);

static int add_location(void);
static int make_selector(char *name,
			 char *value1, char *value2,
			 unsigned int compare);
static void add_selector(struct selector *selector);

static int match_map_option_fs_type(char *map_option, char *type);
static int match_map_option_map_type(char *map_option, char *type);
static int match_map_option_cache_option(char *type);
static int match_mnt_option_options(char *mnt_option, char *options);

static struct amd_entry entry;
static struct list_head *entries;
static struct autofs_point *pap;
struct substvar *psv;
static char opts[MAX_OPTS_LEN];
static void prepend_opt(char *, char *);
static char msg_buf[MAX_ERR_LEN];

#define YYDEBUG 0

#ifndef YYENABLE_NLS
#define YYENABLE_NLS 0
#endif
#ifndef YYLTYPE_IS_TRIVIAL
#define YYLTYPE_IS_TRIVIAL 0
#endif

#if YYDEBUG
static int amd_fprintf(FILE *, char *, ...);
#undef YYFPRINTF
#define YYFPRINTF amd_fprintf
#endif


#line 166 "amd_parse.tab.c"

# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_AMD_AMD_PARSE_TAB_H_INCLUDED
# define YY_AMD_AMD_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int amd_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    COMMENT = 258,
    SEPERATOR = 259,
    SPACE = 260,
    HYPHEN = 261,
    IS_EQUAL = 262,
    CUT = 263,
    NOT_EQUAL = 264,
    COMMA = 265,
    QUOTE = 266,
    OPTION_ASSIGN = 267,
    LBRACKET = 268,
    RBRACKET = 269,
    NOT = 270,
    NILL = 271,
    MAP_OPTION = 272,
    MAP_TYPE = 273,
    CACHE_OPTION = 274,
    FS_TYPE = 275,
    FS_OPTION = 276,
    FS_OPT_VALUE = 277,
    MNT_OPTION = 278,
    SELECTOR = 279,
    SELECTOR_VALUE = 280,
    SEL_ARG_VALUE = 281,
    OPTION = 282,
    MACRO = 283,
    OTHER = 284
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 89 "amd_parse.y"

	char strtype[2048];
	int inttype;
	long longtype;

#line 245 "amd_parse.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE amd_lval;

int amd_parse (void);

#endif /* !YY_AMD_AMD_PARSE_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   61

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  30
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  11
/* YYNRULES -- Number of rules.  */
#define YYNRULES  38
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  58

#define YYUNDEFTOK  2
#define YYMAXUTOK   284

/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  ((unsigned) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   130,   130,   130,   138,   139,   142,   149,   156,   166,
     169,   173,   179,   182,   185,   190,   193,   196,   203,   210,
     217,   224,   231,   238,   245,   252,   261,   266,   271,   318,
     334,   373,   402,   410,   418,   426,   438,   467,   471
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMENT", "SEPERATOR", "SPACE",
  "HYPHEN", "IS_EQUAL", "CUT", "NOT_EQUAL", "COMMA", "QUOTE",
  "OPTION_ASSIGN", "LBRACKET", "RBRACKET", "NOT", "NILL", "MAP_OPTION",
  "MAP_TYPE", "CACHE_OPTION", "FS_TYPE", "FS_OPTION", "FS_OPT_VALUE",
  "MNT_OPTION", "SELECTOR", "SELECTOR_VALUE", "SEL_ARG_VALUE", "OPTION",
  "MACRO", "OTHER", "$accept", "file", "$@1", "line",
  "location_selection_list", "location", "location_entry",
  "selector_or_option", "selection", "option_assignment", "options", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284
};
# endif

#define YYPACT_NINF -34

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-34)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -34,     5,     4,   -34,    14,   -16,     1,    12,    24,     7,
     -34,   -34,    27,   -34,    35,   -34,   -34,   -34,    35,    32,
      22,    25,    -5,    21,    23,    26,    -6,    14,    28,   -34,
     -34,   -34,   -34,   -34,    29,    39,   -34,   -34,   -34,    -7,
      45,   -34,   -34,    20,    40,    29,    31,   -34,     4,    33,
     -34,   -34,   -34,    41,   -34,    44,   -34,   -34
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     4,     1,    11,     0,     0,     0,     0,     0,
      17,     3,     5,     6,     9,    12,    15,    16,    10,     0,
      29,    31,    34,    19,    21,     0,     0,    14,     0,    27,
      35,    26,    28,    30,     0,    36,    32,    18,    20,     0,
       0,     7,    13,     0,     0,    38,     0,    22,     0,     0,
      24,    33,    37,     0,     8,     0,    23,    25
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -34,   -34,   -34,   -34,   -34,   -22,    49,    34,   -34,   -34,
     -33
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     2,    11,    12,    13,    14,    15,    16,    17,
      36
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
       4,    44,    40,    46,    41,     3,    34,    47,    19,     5,
       4,     6,    52,    20,    23,     7,    24,     8,     9,     5,
      25,     6,    35,    10,    21,     7,    54,     8,     9,     5,
      49,     6,    26,    10,    50,     7,    22,     8,     9,    27,
      29,    30,    31,    10,    32,    28,    37,    33,    38,    45,
      48,    51,    39,    18,    43,    56,    35,    53,    57,    55,
       0,    42
};

static const yytype_int8 yycheck[] =
{
       6,    34,     8,    10,    26,     0,    11,    14,    24,    15,
       6,    17,    45,    12,     7,    21,     9,    23,    24,    15,
      13,    17,    27,    29,    12,    21,    48,    23,    24,    15,
      10,    17,     5,    29,    14,    21,    12,    23,    24,     4,
      18,    19,    20,    29,    22,    13,    25,    22,    25,    10,
       5,    11,    26,     4,    26,    14,    27,    26,    14,    26,
      -1,    27
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    31,    32,     0,     6,    15,    17,    21,    23,    24,
      29,    33,    34,    35,    36,    37,    38,    39,    36,    24,
      12,    12,    12,     7,     9,    13,     5,     4,    13,    18,
      19,    20,    22,    22,    11,    27,    40,    25,    25,    26,
       8,    35,    37,    26,    40,    10,    10,    14,     5,    10,
      14,    11,    40,    26,    35,    26,    14,    14
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    30,    32,    31,    33,    33,    34,    34,    34,    35,
      35,    35,    36,    36,    36,    37,    37,    37,    38,    38,
      38,    38,    38,    38,    38,    38,    39,    39,    39,    39,
      39,    39,    39,    39,    39,    39,    40,    40,    40
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     0,     1,     1,     3,     5,     1,
       2,     1,     1,     3,     2,     1,     1,     1,     3,     2,
       3,     2,     4,     6,     5,     7,     3,     3,     3,     2,
       3,     2,     3,     5,     2,     3,     1,     3,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return (YYSIZE_T) (yystpcpy (yyres, yystr) - yyres);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yynewstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  *yyssp = (yytype_int16) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = (YYSIZE_T) (yyssp - yyss + 1);

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 130 "amd_parse.y"
    {
#if YYDEBUG != 0
		amd_debug = YYDEBUG;
#endif
		memset(opts, 0, sizeof(opts));
	}
#line 1380 "amd_parse.tab.c"
    break;

  case 6:
#line 143 "amd_parse.y"
    {
		if (!add_location()) {
			amd_msg("failed to allocate new location");
			YYABORT;
		}
	}
#line 1391 "amd_parse.tab.c"
    break;

  case 7:
#line 150 "amd_parse.y"
    {
		if (!add_location()) {
			amd_msg("failed to allocate new location");
			YYABORT;
		}
	}
#line 1402 "amd_parse.tab.c"
    break;

  case 8:
#line 157 "amd_parse.y"
    {
		entry.flags |= AMD_ENTRY_CUT;
		if (!add_location()) {
			amd_msg("failed to allocate new location");
			YYABORT;
		}
	}
#line 1414 "amd_parse.tab.c"
    break;

  case 9:
#line 167 "amd_parse.y"
    {
	}
#line 1421 "amd_parse.tab.c"
    break;

  case 10:
#line 170 "amd_parse.y"
    {
		entry.flags |= AMD_DEFAULTS_MERGE;
	}
#line 1429 "amd_parse.tab.c"
    break;

  case 11:
#line 174 "amd_parse.y"
    {
		entry.flags |= AMD_DEFAULTS_RESET;
	}
#line 1437 "amd_parse.tab.c"
    break;

  case 12:
#line 180 "amd_parse.y"
    {
	}
#line 1444 "amd_parse.tab.c"
    break;

  case 13:
#line 183 "amd_parse.y"
    {
	}
#line 1451 "amd_parse.tab.c"
    break;

  case 14:
#line 186 "amd_parse.y"
    {
	}
#line 1458 "amd_parse.tab.c"
    break;

  case 15:
#line 191 "amd_parse.y"
    {
	}
#line 1465 "amd_parse.tab.c"
    break;

  case 16:
#line 194 "amd_parse.y"
    {
	}
#line 1472 "amd_parse.tab.c"
    break;

  case 17:
#line 197 "amd_parse.y"
    {
		amd_notify((yyvsp[0].strtype));
		YYABORT;
	}
#line 1481 "amd_parse.tab.c"
    break;

  case 18:
#line 204 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-2].strtype), (yyvsp[0].strtype), NULL, SEL_COMP_EQUAL)) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
	}
#line 1492 "amd_parse.tab.c"
    break;

  case 19:
#line 211 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-1].strtype), "", NULL, SEL_COMP_EQUAL)) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1503 "amd_parse.tab.c"
    break;

  case 20:
#line 218 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-2].strtype), (yyvsp[0].strtype), NULL, SEL_COMP_NOTEQUAL)) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
	}
#line 1514 "amd_parse.tab.c"
    break;

  case 21:
#line 225 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-1].strtype), "", NULL, SEL_COMP_EQUAL)) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1525 "amd_parse.tab.c"
    break;

  case 22:
#line 232 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-3].strtype), (yyvsp[-1].strtype), NULL, SEL_COMP_NONE)) {
			amd_notify((yyvsp[-3].strtype));
			YYABORT;
		}
	}
#line 1536 "amd_parse.tab.c"
    break;

  case 23:
#line 239 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-5].strtype), (yyvsp[-3].strtype), (yyvsp[-1].strtype), SEL_COMP_NONE)) {
			amd_notify((yyvsp[-5].strtype));
			YYABORT;
		}
	}
#line 1547 "amd_parse.tab.c"
    break;

  case 24:
#line 246 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-3].strtype), (yyvsp[-1].strtype), NULL, SEL_COMP_NOT)) {
			amd_notify((yyvsp[-3].strtype));
			YYABORT;
		}
	}
#line 1558 "amd_parse.tab.c"
    break;

  case 25:
#line 253 "amd_parse.y"
    {
		if (!make_selector((yyvsp[-5].strtype), (yyvsp[-3].strtype), (yyvsp[-1].strtype), SEL_COMP_NOT)) {
			amd_notify((yyvsp[-5].strtype));
			YYABORT;
		}
	}
#line 1569 "amd_parse.tab.c"
    break;

  case 26:
#line 262 "amd_parse.y"
    {
		if (!match_map_option_fs_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
			YYABORT;
	}
#line 1578 "amd_parse.tab.c"
    break;

  case 27:
#line 267 "amd_parse.y"
    {
		if (!match_map_option_map_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
			YYABORT;
	}
#line 1587 "amd_parse.tab.c"
    break;

  case 28:
#line 272 "amd_parse.y"
    {
		/* Quoted value for type, maptype or cache assign */
		if (!strcmp((yyvsp[-2].strtype), "type")) {
			if (!match_map_option_fs_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
				YYABORT;
		} else if (!strcmp((yyvsp[-2].strtype), "maptype")) {
			if (!match_map_option_map_type((yyvsp[-2].strtype), (yyvsp[0].strtype)))
				YYABORT;
		} else if (!strcmp((yyvsp[-2].strtype), "cache")) {
			if (!match_map_option_cache_option((yyvsp[0].strtype)))
				YYABORT;
		} else {
			char *fs_opt_val;

			fs_opt_val = amd_strdup((yyvsp[0].strtype));
			if (!fs_opt_val) {
				amd_notify((yyvsp[0].strtype));
				YYABORT;
			}

			if (!strcmp((yyvsp[-2].strtype), "fs"))
				amd_set_value(&entry.fs, fs_opt_val);
			else if (!strcmp((yyvsp[-2].strtype), "sublink")) {
				amd_set_value(&entry.sublink, fs_opt_val);
			} else if (!strcmp((yyvsp[-2].strtype), "pref")) {
				if (strcmp(fs_opt_val, "null"))
					amd_set_value(&entry.pref, fs_opt_val);
				else {
					char *empty;

					empty = amd_strdup("");
					if (!empty) {
						amd_notify((yyvsp[0].strtype));
						free(fs_opt_val);
						YYABORT;
					}
					amd_set_value(&entry.pref, empty);
					free(fs_opt_val);
				}
			} else {
				amd_notify((yyvsp[-2].strtype));
				free(fs_opt_val);
				YYABORT;
			}
		}
	}
#line 1638 "amd_parse.tab.c"
    break;

  case 29:
#line 319 "amd_parse.y"
    {
		if (!strcmp((yyvsp[-1].strtype), "fs")) {
			char *empty;

			empty = amd_strdup("");
			if (!empty) {
				amd_notify((yyvsp[-1].strtype));
				YYABORT;
			}
			amd_set_value(&entry.fs, empty);
		} else {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1658 "amd_parse.tab.c"
    break;

  case 30:
#line 335 "amd_parse.y"
    {
		char *fs_opt_val;

		fs_opt_val = amd_strdup((yyvsp[0].strtype));
		if (!fs_opt_val) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}

		if (!strcmp((yyvsp[-2].strtype), "rhost"))
			amd_set_value(&entry.rhost, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "rfs"))
			amd_set_value(&entry.rfs, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "dev"))
			amd_set_value(&entry.dev, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "mount"))
			amd_set_value(&entry.mount, fs_opt_val);
		else if (!strcmp((yyvsp[-2].strtype), "unmount") ||
			 !strcmp((yyvsp[-2].strtype), "umount")) {
			if (entry.umount) {
				sprintf(msg_buf,
				    "unmount or umount may only be used once");
				amd_info(msg_buf);
				free(fs_opt_val);
				YYABORT;
			}
			entry.umount = fs_opt_val;
		} else if (!strcmp((yyvsp[-2].strtype), "delay") ||
			   !strcmp((yyvsp[-2].strtype), "cachedir")) {
			sprintf(msg_buf, "option %s is not used by autofs", (yyvsp[-2].strtype));
			amd_info(msg_buf);
			free(fs_opt_val);
		} else {
			amd_notify((yyvsp[-2].strtype));
			free(fs_opt_val);
			YYABORT;
		}
	}
#line 1701 "amd_parse.tab.c"
    break;

  case 31:
#line 374 "amd_parse.y"
    {
		char *empty;

		empty = amd_strdup("");
		if (!empty) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}

		if (!strcmp((yyvsp[-1].strtype), "rhost"))
			amd_set_value(&entry.rhost, empty);
		else if (!strcmp((yyvsp[-1].strtype), "rfs"))
			amd_set_value(&entry.rfs, empty);
		else if (!strcmp((yyvsp[-1].strtype), "dev"))
			amd_set_value(&entry.dev, empty);
		else if (!strcmp((yyvsp[-1].strtype), "mount")) {
			amd_set_value(&entry.mount, NULL);
			free(empty);
		} else if (!strcmp((yyvsp[-1].strtype), "umount") ||
			   !strcmp((yyvsp[-1].strtype), "unmount")) {
			amd_set_value(&entry.umount, NULL);
			free(empty);
		} else {
			amd_notify((yyvsp[-1].strtype));
			free(empty);
			YYABORT;
		}
	}
#line 1734 "amd_parse.tab.c"
    break;

  case 32:
#line 403 "amd_parse.y"
    {
		if (!match_mnt_option_options((yyvsp[-2].strtype), opts)) {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
		memset(opts, 0, sizeof(opts));
	}
#line 1746 "amd_parse.tab.c"
    break;

  case 33:
#line 411 "amd_parse.y"
    {
		if (!match_mnt_option_options((yyvsp[-4].strtype), opts)) {
			amd_notify((yyvsp[-4].strtype));
			YYABORT;
		}
		memset(opts, 0, sizeof(opts));
	}
#line 1758 "amd_parse.tab.c"
    break;

  case 34:
#line 419 "amd_parse.y"
    {
		memset(opts, 0, sizeof(opts));
		if (!match_mnt_option_options((yyvsp[-1].strtype), "")) {
			amd_notify((yyvsp[-1].strtype));
			YYABORT;
		}
	}
#line 1770 "amd_parse.tab.c"
    break;

  case 35:
#line 427 "amd_parse.y"
    {
		if (!strcmp((yyvsp[-2].strtype), "cache")) {
			if (!match_map_option_cache_option((yyvsp[0].strtype)))
				YYABORT;
		} else {
			amd_notify((yyvsp[-2].strtype));
			YYABORT;
		}
	}
#line 1784 "amd_parse.tab.c"
    break;

  case 36:
#line 439 "amd_parse.y"
    {
		if (!strcmp((yyvsp[0].strtype), "fullybrowsable") ||
		    !strcmp((yyvsp[0].strtype), "nounmount")) {
			sprintf(msg_buf, "option %s is not currently "
					 "implemented, ignored", (yyvsp[0].strtype));
			amd_info(msg_buf);
		} else if (!strncmp((yyvsp[0].strtype), "ping=", 5) ||
			   !strncmp((yyvsp[0].strtype), "retry=", 6) ||
			   !strcmp((yyvsp[0].strtype), "public") ||
			   !strcmp((yyvsp[0].strtype), "softlookup") ||
			   !strcmp((yyvsp[0].strtype), "xlatecookie")) {
			sprintf(msg_buf, "option %s is not used by "
					 "autofs, ignored", (yyvsp[0].strtype));
			amd_info(msg_buf);
		} else if (!strncmp((yyvsp[0].strtype), "utimeout=", 9)) {
			if (entry.flags & AMD_MOUNT_TYPE_AUTO) {
				char *opt = (yyvsp[0].strtype);
				prepend_opt(opts, ++opt);
			} else {
				sprintf(msg_buf, "umount timeout can't be "
						 "used for other than type "
						 "\"auto\" with autofs, "
						 "ignored");
				amd_info(msg_buf);
			}
		} else
			prepend_opt(opts, (yyvsp[0].strtype));
	}
#line 1817 "amd_parse.tab.c"
    break;

  case 37:
#line 468 "amd_parse.y"
    {
		prepend_opt(opts, (yyvsp[-2].strtype));
	}
#line 1825 "amd_parse.tab.c"
    break;

  case 38:
#line 472 "amd_parse.y"
    {
		prepend_opt(opts, (yyvsp[-1].strtype));
	}
#line 1833 "amd_parse.tab.c"
    break;


#line 1837 "amd_parse.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 477 "amd_parse.y"


static int match_map_option_fs_type(char *map_option, char *type)
{
	char *fs_type;

	fs_type = amd_strdup(type);
	if (!fs_type) {
		amd_notify(type);
		return 0;
	}

	if (!strcmp(fs_type, "auto"))
		entry.flags |= AMD_MOUNT_TYPE_AUTO;
	else if (!strcmp(fs_type, "nfs") ||
		 !strcmp(fs_type, "nfs4"))
		entry.flags |= AMD_MOUNT_TYPE_NFS;
	else if (!strcmp(fs_type, "nfsl"))
		entry.flags |= AMD_MOUNT_TYPE_NFSL;
	else if (!strcmp(fs_type, "link"))
		entry.flags |= AMD_MOUNT_TYPE_LINK;
	else if (!strcmp(fs_type, "linkx"))
		entry.flags |= AMD_MOUNT_TYPE_LINKX;
	else if (!strcmp(fs_type, "host"))
		entry.flags |= AMD_MOUNT_TYPE_HOST;
	else if (!strcmp(fs_type, "lofs"))
		entry.flags |= AMD_MOUNT_TYPE_LOFS;
	else if (!strcmp(fs_type, "xfs"))
		entry.flags |= AMD_MOUNT_TYPE_XFS;
	else if (!strcmp(fs_type, "ext2") ||
		   !strcmp(fs_type, "ext3") ||
		   !strcmp(fs_type, "ext4"))
		entry.flags |= AMD_MOUNT_TYPE_EXT;
	else if (!strcmp(fs_type, "program"))
		entry.flags |= AMD_MOUNT_TYPE_PROGRAM;
	else if (!strcmp(fs_type, "ufs")) {
		entry.flags |= AMD_MOUNT_TYPE_UFS;
		entry.type = conf_amd_get_linux_ufs_mount_type();
		if (!entry.type) {
			amd_msg("memory allocation error");
			amd_notify(type);
			free(fs_type);
			return 0;
		}
		free(fs_type);
		fs_type = NULL;
	} else if (!strcmp(fs_type, "cdfs")) {
		entry.flags |= AMD_MOUNT_TYPE_CDFS;
		entry.type = amd_strdup("iso9660");
		if (!entry.type) {
			amd_msg("memory allocation error");
			amd_notify(map_option);
			free(fs_type);
			return 0;
		}
		free(fs_type);
		fs_type = NULL;
	} else if (!strcmp(fs_type, "jfs") ||
		   !strcmp(fs_type, "nfsx") ||
		   !strcmp(fs_type, "lustre") ||
		   !strcmp(fs_type, "direct")) {
		sprintf(msg_buf, "file system type %s is "
				 "not yet implemented", fs_type);
		amd_msg(msg_buf);
		free(fs_type);
		return 0;
	} else if (!strcmp(fs_type, "cachefs")) {
		sprintf(msg_buf, "file system %s is not "
				 "supported by autofs, ignored",
				 fs_type);
		amd_msg(msg_buf);
		free(fs_type);
		fs_type = NULL;
	} else {
		amd_notify(fs_type);
		free(fs_type);
		return 0;
	}

	if (fs_type)
		amd_set_value(&entry.type, fs_type);

	return 1;
}

static int match_map_option_map_type(char *map_option, char *type)
{
	char *map_type;

	map_type = amd_strdup(type);
	if (!map_type) {
		amd_notify(type);
		return 0;
	}

	if (!strcmp(map_type, "file") ||
	    !strcmp(map_type, "nis") ||
	    !strcmp(map_type, "nisplus") ||
	    !strcmp(map_type, "ldap") ||
	    !strcmp(map_type, "hesiod")) {
#ifndef WITH_HESIOD
		if (!strcmp(map_type, "hesiod")) {
			amd_msg("hesiod support not built in");
			free(map_type);
			return 0;
		}
#endif
		amd_set_value(&entry.map_type, map_type);
	} else if (!strcmp(map_type, "exec")) {
		/* autofs uses "program" for "exec" map type */
		char * tmp;

		tmp = amd_strdup("program");
		if (!tmp) {
			amd_notify(type);
			free(map_type);
			return 0;
		}
		amd_set_value(&entry.map_type, tmp);
		free(map_type);
	} else if (!strcmp(map_type, "passwd")) {
		sprintf(msg_buf, "map type %s is "
				 "not yet implemented", map_type);
		amd_msg(msg_buf);
		free(map_type);
		return 0;
	} else if (!strcmp(map_type, "ndbm") ||
		   !strcmp(map_type, "union")) {
		sprintf(msg_buf, "map type %s is not "
				 "supported by autofs", map_type);
		amd_msg(msg_buf);
		free(map_type);
		return 0;
	} else {
		amd_notify(type);
		free(map_type);
		return 0;
	}

	return 1;
}

static int match_map_option_cache_option(char *type)
{
	char *cache_opt;

	cache_opt = amd_strdup(type);
	if (!cache_opt) {
		amd_notify(type);
		return 0;
	}

	if (strncmp(cache_opt, "inc", 3))
		entry.cache_opts = AMD_CACHE_OPTION_INC;
	else if (strncmp(cache_opt, "all", 3))
		entry.cache_opts = AMD_CACHE_OPTION_ALL;
	else if (strncmp(cache_opt, "re", 2))
		entry.cache_opts = AMD_CACHE_OPTION_REGEXP;
	if (strstr(cache_opt, "sync"))
		entry.cache_opts |= AMD_CACHE_OPTION_SYNC;
	free(cache_opt);

	return 1;
}

static int match_mnt_option_options(char *mnt_option, char *options)
{
	char *tmp;

	if (!strcmp(mnt_option, "opts")) {
		tmp = amd_strdup(options);
		if (!tmp)
			return 0;
		amd_set_value(&entry.opts, tmp);
	} else if (!strcmp(mnt_option, "addopts")) {
		tmp = amd_strdup(options);
		if (!tmp)
			return 0;
		amd_set_value(&entry.addopts, tmp);
	} else if (!strcmp(mnt_option, "remopts")) {
		tmp = amd_strdup(options);
		if (!tmp)
			return 0;
		amd_set_value(&entry.remopts, tmp);
	} else
		return 0;

	return 1;
}

static void prepend_opt(char *dest, char *opt)
{
	char new[MAX_OPTS_LEN];
	strcpy(new, opt);
	if (*dest != '\0') {
		strcat(new, ",");
		strcat(new, dest);
	}
	memmove(dest, new, strlen(new));
}

#if YYDEBUG
static int amd_fprintf(FILE *f, char *msg, ...)
{
	va_list ap;
	va_start(ap, msg);
	vsyslog(LOG_DEBUG, msg, ap);
	va_end(ap);
	return 1;
}
#endif

static char *amd_strdup(char *str)
{
	unsigned int quoted, len;
	char *tmp;

	len = strlen(str);
	quoted = 0;

	if (*str == '"') {
		quoted = 1;
		len -= 2;
	}

	tmp = strdup(str + quoted);
	if (!tmp) {
		amd_msg("memory allocation error");
		return NULL;
	} else {
		unsigned int squote;
		char *ptr;

		if (quoted) {
			if (tmp[len] != '"') {
				sprintf(msg_buf,
					"unmatched double quote near: %s", str);
				amd_info(msg_buf);
				free(tmp);
				return NULL;
			}
			tmp[len] = 0;
		}

		/* Check for matching single quotes */
		if (!strchr(tmp, 39))
			goto done;

		ptr = tmp;
		squote = 0;
		while (*ptr) {
			if (*ptr == 39)
				squote = !squote;
			ptr++;
		}
		if (squote) {
			sprintf(msg_buf,
				"unmatched single quote near: %s", str);
			amd_info(msg_buf);
			free(tmp);
			return NULL;
		}
	}
done:
	return tmp;
}

static void amd_set_value(char **field, char *value)
{
	if (*field)
		free(*field);
	*field = value;
}

static int amd_error(const char *s)
{
	if (strcmp(s, "syntax"))
		logmsg("syntax error in location near [ %s ]\n", amd_text);
	else
		logmsg("%s while parsing location.\n", s);
	return 0;
}

static int amd_notify(const char *s)
{
	logmsg("syntax error in location near [ %s ]\n", s);
	return(0);
}

static int amd_info(const char *s)
{
	info(pap->logopt, "%s\n", s);
	return 0;
}

static int amd_msg(const char *s)
{
	logmsg("%s\n", s);
	return 0;
}

static void local_init_vars(void)
{
	memset(&entry, 0, sizeof(entry));
	entry.cache_opts = AMD_CACHE_OPTION_NONE;
	memset(opts, 0, sizeof(opts));
}

static void local_free_vars(void)
{
	clear_amd_entry(&entry);
	return;
}

static void add_selector(struct selector *selector)
{
	struct selector *s = entry.selector;

	if (!s) {
		entry.selector = selector;
		return;
	}

	while (s->next)
		s = s->next;

	selector->next = s;
	entry.selector = selector;

	return;
}

static int make_selector(char *name,
			 char *value1, char *value2,
			 unsigned int compare)
{
	struct selector *s;
	char *tmp;

	if (!sel_lookup(name))
		return 0;

	s = get_selector(name);
	if (!s)
		return 0;

	if (s->sel->flags & SEL_FLAG_MACRO) {
		tmp = amd_strdup(value1);
		if (!tmp)
			goto error;
		s->comp.value = tmp;
	} else if (s->sel->flags & SEL_FLAG_FUNC1) {
		if (!value1)
			tmp = NULL;
		else {
			tmp = amd_strdup(value1);
			if (!tmp)
				goto error;
		}
		s->func.arg1 = tmp;
	} else if (s->sel->flags & SEL_FLAG_FUNC2) {
		tmp = amd_strdup(value1);
		if (!tmp)
			goto error;
		s->func.arg1 = tmp;
		if (value2) {
			tmp = amd_strdup(value2);
			if (tmp)
				s->func.arg2 = tmp;
		}
	}
	s->compare = compare;

	add_selector(s);

	return 1;
error:
	free_selector(s);
	return 0;
}

void amd_init_scan(void)
{
}

static void parse_mutex_lock(void)
{
	int status = pthread_mutex_lock(&parse_mutex);
	if (status)
		fatal(status);
	return;
}

static void parse_mutex_unlock(void *arg)
{
	int status = pthread_mutex_unlock(&parse_mutex);
	if (status)
		fatal(status);
	return;
}

static int add_location(void)
{
	struct amd_entry *new;

	new = new_amd_entry(psv);
	if (!new)
		return 0;

	if (entry.path) {
		free(new->path);
		new->path = entry.path;
	}
	new->flags = entry.flags;
	new->type = entry.type;
	new->map_type = entry.map_type;
	new->pref = entry.pref;
	new->fs = entry.fs;
	new->rhost = entry.rhost;
	new->rfs = entry.rfs;
	new->dev = entry.dev;
	new->opts = entry.opts;
	new->addopts = entry.addopts;
	new->remopts = entry.remopts;
	new->sublink = entry.sublink;
	new->mount = entry.mount;
	new->umount = entry.umount;
	new->selector = entry.selector;
	list_add_tail(&new->list, entries);
	memset(&entry, 0, sizeof(struct amd_entry));

	return 1;
}

int amd_parse_list(struct autofs_point *ap,
		   const char *buffer, struct list_head *list,
		   struct substvar **sv)
{
	char *buf;
	size_t len;
	int ret;

	len = strlen(buffer) + 2;
	buf = malloc(len);
	if (!buf)
		return 0;
	strcpy(buf, buffer);

	parse_mutex_lock();
	pthread_cleanup_push(parse_mutex_unlock, NULL);

	pap = ap;
	psv = *sv;
	entries = list;
	amd_set_scan_buffer(buf);

	local_init_vars();
	ret = amd_parse();
	local_free_vars();
	*sv = psv;

	pthread_cleanup_pop(1);
	free(buf);

	return ret;
}
